#include "StdAfx.h"
#include "MicroPacketUtil.h"

CMicroPacketUtil::CMicroPacketUtil(void)
{
	Reset();
}

CMicroPacketUtil::~CMicroPacketUtil(void)
{
}

BOOL CMicroPacketUtil::MicroPacket(BYTE* pbPacket)
{
	BOOL bRet = FALSE;

	uint packetCounter = BIT_SHIFT_MASK(pbPacket[3], 2,  3);
	uint packetStart   = BIT_SHIFT_MASK(pbPacket[3], 1,  1);

	// JE^lmF
	uint count = BIT_SHIFT_MASK(mCount, 0, 3);
	mCount++;

	if (packetCounter != count) {
		OutputDebugString(L"JE^lُłB\n");
		Reset();
		return FALSE;
	}

	// pPbgJnʒutOmF
	if (packetStart) {
		// oCgmF
		if (pbPacket[2] != 0x47) {
			OutputDebugString(L"pPbg̐擪oCg 0x47 ɂȂĂ܂B\n");
		}

		if (mPacketOffset != 0) {
			OutputDebugString(L"ÕpPbg܂łB\n");
		}
		mPacketOffset = 0;
	}

	// f[^Rs[
	for (int i=2; i>=0; i--) {
		if (mPacketOffset < 188) {
			m_b1TS[mPacketOffset] = pbPacket[i];
			mPacketOffset++;
		}
	}

	if (188 <= mPacketOffset) {
		// ЂƂ̃pPbg
		mPacketOffset = 0;
		bRet = TRUE;
	}

	return bRet;
}
